extends Control


# Called when the node enters the scene tree for the first time.
func _ready():
	var args = OS.get_cmdline_args()
	for a in args:
		if a == "-s":
			_start_server()
		elif a == "-c":
			_start_client()

const Player = preload("res://player.tscn")
var peer = ENetMultiplayerPeer.new()

func _start_client():
	print("starting client")
	peer.create_client("127.0.0.1", 4333)
	multiplayer.multiplayer_peer = peer
	multiplayer.peer_connected.connect(_on_client_peer)
	multiplayer.connected_to_server.connect(_on_connected)


func _start_server():
	print("starting server")
	peer.create_server(4333)
	multiplayer.multiplayer_peer = peer
	multiplayer.peer_connected.connect(_on_server_peer)
	add_player(1)
	pass


func add_player(id):
	var p = Player.instantiate()
	p.name = str(id)
	p.text = p.name
	p.public = false
	%AutoSpawned.add_child(p)
	%CustomSpawner.spawn(id)


func _on_connected():
	print("Connected")


func _on_client_peer(p_id):
	print("Peer connected")


func _on_server_peer(p_id):
	print("Peer connected")
	add_player(p_id)


func _on_client_toggled(button_pressed):
	if button_pressed:
		_start_client()
	else:
		peer.close_connection()


func _on_server_toggled(button_pressed):
	if button_pressed:
		_start_server()
	else:
		peer.close_connection()
