extends Label

@export
var public := true
@export
var show_to_peer := false

func _enter_tree():
	#%StaticSync.set_visibility_override(is_visible_to)
	%PlayerSync.set_visibility_override(is_visible_to)
	print("Entering tree %s, visible %s %s" % [text.to_int(), public, show_to_peer])

func _ready():
	print("Ready %s, visible %s %s" % [text.to_int(), public, show_to_peer])


func is_visible_to(peer):
	return public or (show_to_peer and str(peer) == str(name))


func _process(delta):
	if not is_multiplayer_authority():
		return
	%Counter.value += delta
	%StaticCounter.value += delta


func _on_all_toggled(button_pressed):
	if not is_multiplayer_authority():
		return
	public = button_pressed
	if public: # Ensure this gets spawned before items.
		%PlayerSync.update_visibility()

	%StaticSync.public_visibility = button_pressed
	%ItemSpawner.public = button_pressed


func _on_one_toggled(button_pressed):
	if not is_multiplayer_authority() or str(name).to_int() == get_multiplayer_authority():
		return
	show_to_peer = button_pressed
	if show_to_peer: # Ensure this gets spawned before items.
		%PlayerSync.update_visibility()

	%StaticSync.set_visibility_for(str(name).to_int(), button_pressed)
	%ItemSpawner.show_to_peer = str(name).to_int() if button_pressed else 1


func _on_spawn_pressed():
	%ItemSpawner.spawn()


func _on_despawn_pressed():
	%ItemSpawner.despawn()
